/**
==========================================================================
AdpMysql.cpp : MTU adaptor for MySQL 

This software is a utility for data migration 
into MySQL from Oracle database. 

Best feature is efficient data transmission. because it can be received 
a data via "Named-pipe" that requires no temporary storage.
"Named-pipe" is provided by MTU when it is running.

Supported data types are:
  VARCHAR2, CHAR, NVARCHAR2, NCHAR, DATE, NUMBER, LONG, LONG RAW
  , CLOB, NCLOB and BLOB.

How to build:
1. Prepare to VC++ 2013 or later.
2. Start the developer's command prompt.
3. To make a program, run a statement following.
nmake EXE="AdpMysql.exe" OBJS="AdpMysql.obj" CPPFLAGS="/EHsc /nologo /O2 /MD 
 /DNDEBUG /I path_to_mysql_home_dir\include"

Usage:
AdpMysql <table_name> <bulk_size> <[path_to_mysql_home_dir\lib\]libmysql.dll>
--------------------------------------------------------------------------
Copyright (c) 2014 PLUMSIX Co.,Ltd.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================================
*/

/**
 *
 * OtpCvCSVf[^ǂݍ݁ASDF ` LOB f[^
 * ǎAMySQL f[^x[X̃e[u֊i[܂B
 * 
 * ȉ̃INEf[^x[X̃f[^^ɑΉ܂B
 * VARCHAR2, CHAR, NVARCHAR2, NCHAR, DATE, NUMBER, LONG, LONG RAW
 *   , CLOB, NCLOB, BLOBB
 * 
 * iMTU v4.2.1 ȍ~̔łɑΉj
 * 
 * (C) 2014 Plumsix Co.,Ltd.
 *
 * rhɕKvȊAVC++ 2013 ܂͂ȍ~̃o[W
 *
 * g:
 * query   // MTU ɋN
 * AdpMysql DB_MIG_TEST 20 [path_to_mysql_home_dir\lib\]libmysql.dll
 * : e[uA
 * : oNTCY
 * O: libmysql.dll t@Cւ̃pX
 * LOB ^܂܂e[ȕꍇAoNPʂ
 * LOBFILEf[^ꊇăpCv֏ôŁA
 *  BULK_SIZE ɂȂƃnO܂B
 *
 * ɏڂF
 http://www.mtu-accelerates.jp/mig_mysql_v2_01/
 */

// MySQL ւ̐ڑ`
#define HOST    "localhost"
#define PORT    13306   // SSH will foward data which sent to this port.
#define USER    "scott"
#define PASSWD  "tiger"
#define DB      "scott"

#define MAX_VALUE_LENGTH   INT_MAX // for detection abnormal value size.

// f[^̓ǂݎ`
const char src_header[] = {
#if 1
// set STDOUT=0x0007 /* et@Cɑf[^OtpCv֏o */
	"\\\\.\\pipe\\"
#else
// set STDOUT=0x0000 /* et@C̓t@CVXe֏o */
//	"C:\\ProgramData\\PLUMSIX\\mtu_4.2\\x86\\output\\"
	"C:\\ProgramData\\PLUMSIX\\mtu_4.2\\x64\\output\\"
#endif
};

#define _CRT_SECURE_NO_WARNINGS         // to escape error C4999.

#include <string>
#include <cassert>
#include <iostream>
#include <fstream>
#include <sstream>
#include <codecvt>
#include <vector>
#include <list>
#include <map>
#include <memory>
#include <algorithm>
#include <thread>
#include <mutex>
#include <regex>

#include <my_global.h>
#include <mysql.h>

#define STR_ENCLOSURE "~~"              // ϐ ENCLOSER Ɠ̂w
#define INTERVAL_FOR_EACH_COMMIT 10000  // wsR~bg
#define VAR_FIELD_LENGTH 10             // LONG ^ACLOB/NCLOB ^̃f[^
                                        // tB[h

typedef std::vector<std::string> strvector;
typedef std::list<std::string> strlist;
typedef std::vector<int> intvector;
typedef std::basic_regex<char> regex;
typedef std::match_results<std::string::const_iterator> cmatch;

class cErrWin32Api : public std::runtime_error
{
private:
	DWORD iErrCode_;
	std::string msg;
	std::string sErrCodeToMsg(const DWORD& iErrCode)
	{
		LPSTR lpMsgBuf = NULL;
		DWORD iMsgBuf = ::FormatMessageA(
			FORMAT_MESSAGE_ALLOCATE_BUFFER
			| FORMAT_MESSAGE_FROM_SYSTEM   /* source and processing options */
			, NULL                            /* pointer to  message source */
			, iErrCode                      /* requested message identifier */
			, MAKELANGID(LANG_ENGLISH, SUBLANG_DEFAULT) /* Default language */
			, (LPSTR)&lpMsgBuf                 /* pointer to message buffer */
			, 0                          /* maximum size of message buffer  */
			, NULL                  /* address of array of message inserts  */
			);
		std::string msg(lpMsgBuf, iMsgBuf);
		std::string::size_type idx = msg.rfind("\r\n");
		if (idx != std::string::npos)
		{
			lpMsgBuf[idx] = '\0';
		}
		std::ostringstream oss;
		oss.setf(std::ios_base::hex, std::ios_base::basefield);
		oss.setf(std::ios_base::showbase);
		oss << "Code=" << iErrCode << ":" << std::string(lpMsgBuf, iMsgBuf);
		::LocalFree(lpMsgBuf);
		return oss.str();
	}
public:
	cErrWin32Api(const std::string prefix ="")
		: std::runtime_error(prefix), iErrCode_(::GetLastError())
		, msg(sErrCodeToMsg(iErrCode_))
	{
		std::string prefix_ = std::runtime_error::what();
		if (!prefix_.empty()) prefix_ += " : ";
		msg.insert(0, prefix_);
	}
	virtual const char* what() const throw()
	{
		::OutputDebugStringA(msg.c_str());
		return msg.c_str();
	}
	DWORD iGetErrCode() const
	{
		return iErrCode_;
	}
	virtual ~cErrWin32Api()
	{}
};

class cExternalModule
{
private:
	HMODULE hModule_;
	cExternalModule(const cExternalModule&);
	cExternalModule& operator=(const cExternalModule&);
protected:
	cExternalModule(const std::string& sModuleName)
		: hModule_(0)
	{
		std::cout << "Loading library " << sModuleName << std::endl;
		hModule_ = ::LoadLibrary(sModuleName.c_str()); 
		if (hModule_ == 0) throw cErrWin32Api(__FUNCTION__);
	}
	~cExternalModule()
	{
		::FreeLibrary(hModule_);
	}
	template<typename T>
	void vGetProcAddr(const std::string& sProcName, T& proc)
	{
		proc = reinterpret_cast<T>(::GetProcAddress(hModule_, sProcName.c_str()));
		if (proc == 0) throw cErrWin32Api(std::string(__FUNCTION__)
				+ " sProcName="+ sProcName);
	}
};

namespace nsMysql {

const char * (STDCALL *mysql_character_set_name)(MYSQL *mysql);
int          (STDCALL *mysql_set_character_set)(MYSQL *mysql, 
				   const char *csname);
MYSQL* (STDCALL *mysql_init)(MYSQL *mysql);
my_bool		(STDCALL *mysql_ssl_set)(MYSQL *mysql, const char *key,
				      const char *cert, const char *ca,
				      const char *capath, const char *cipher);
const char *    (STDCALL *mysql_get_ssl_cipher)(MYSQL *mysql);
unsigned int (STDCALL *mysql_errno)(MYSQL *mysql);
const char * (STDCALL *mysql_error)(MYSQL *mysql);
MYSQL* (STDCALL *mysql_real_connect)(MYSQL *mysql, const char *host,
				   const char *user,
				   const char *passwd,
				   const char *db,
				   unsigned int port,
				   const char *unix_socket,
				   unsigned long clientflag);
int (STDCALL *mysql_query)(MYSQL *mysql, const char *q);
MYSQL_RES * (STDCALL *mysql_use_result)(MYSQL *mysql);
unsigned long	(STDCALL *mysql_get_client_version)(void);
unsigned long	(STDCALL *mysql_get_server_version)(MYSQL *mysql);
int		(STDCALL *mysql_options)(MYSQL *mysql,enum mysql_option option,
				      const void *arg);
void (STDCALL *mysql_free_result)(MYSQL_RES *result);
MYSQL_ROW (STDCALL *mysql_fetch_row)(MYSQL_RES *result);
unsigned int	(STDCALL *mysql_thread_safe)(void);

MYSQL_STMT * (STDCALL *mysql_stmt_init)(MYSQL *mysql);
int (STDCALL *mysql_stmt_prepare)(MYSQL_STMT *stmt, const char *query,
                               unsigned long length);
int (STDCALL *mysql_stmt_execute)(MYSQL_STMT *stmt);
int (STDCALL *mysql_stmt_fetch)(MYSQL_STMT *stmt);
int (STDCALL *mysql_stmt_fetch_column)(MYSQL_STMT *stmt,
								    MYSQL_BIND *bind_arg, 
                                    unsigned int column,
                                    unsigned long offset);
int (STDCALL *mysql_stmt_store_result)(MYSQL_STMT *stmt);
unsigned long (STDCALL *mysql_stmt_param_count)(MYSQL_STMT * stmt);
my_bool (STDCALL *mysql_stmt_attr_set)(MYSQL_STMT *stmt,
                                    enum enum_stmt_attr_type attr_type,
                                    const void *attr);
my_bool (STDCALL *mysql_stmt_attr_get)(MYSQL_STMT *stmt,
                                    enum enum_stmt_attr_type attr_type,
                                    void *attr);
my_bool (STDCALL *mysql_stmt_bind_param)(MYSQL_STMT * stmt, 
					MYSQL_BIND * bnd);
my_bool (STDCALL *mysql_stmt_bind_result)(MYSQL_STMT * stmt, 
					MYSQL_BIND * bnd);
my_bool (STDCALL *mysql_stmt_close)(MYSQL_STMT * stmt);
my_bool (STDCALL *mysql_stmt_reset)(MYSQL_STMT * stmt);
my_bool (STDCALL *mysql_stmt_free_result)(MYSQL_STMT *stmt);
my_bool (STDCALL *mysql_stmt_send_long_data)(MYSQL_STMT *stmt, 
                                          unsigned int param_number,
                                          const char *data, 
                                          unsigned long length);
MYSQL_RES *(STDCALL *mysql_stmt_result_metadata)(MYSQL_STMT *stmt);
MYSQL_RES *(STDCALL *mysql_stmt_param_metadata)(MYSQL_STMT *stmt);
unsigned int (STDCALL *mysql_stmt_errno)(MYSQL_STMT * stmt);
const char *(STDCALL *mysql_stmt_error)(MYSQL_STMT * stmt);
const char *(STDCALL *mysql_stmt_sqlstate)(MYSQL_STMT * stmt);
MYSQL_ROW_OFFSET (STDCALL *mysql_stmt_row_seek)(MYSQL_STMT *stmt, 
                                             MYSQL_ROW_OFFSET offset);
MYSQL_ROW_OFFSET (STDCALL *mysql_stmt_row_tell)(MYSQL_STMT *stmt);
void (STDCALL *mysql_stmt_data_seek)(MYSQL_STMT *stmt, my_ulonglong offset);
my_ulonglong (STDCALL *mysql_stmt_num_rows)(MYSQL_STMT *stmt);
my_ulonglong (STDCALL *mysql_stmt_affected_rows)(MYSQL_STMT *stmt);
my_ulonglong (STDCALL *mysql_stmt_insert_id)(MYSQL_STMT *stmt);
unsigned int (STDCALL *mysql_stmt_field_count)(MYSQL_STMT *stmt);

my_bool (STDCALL *mysql_commit)(MYSQL * mysql);
my_bool (STDCALL *mysql_rollback)(MYSQL * mysql);
my_bool (STDCALL *mysql_autocommit)(MYSQL * mysql, my_bool auto_mode);
my_bool (STDCALL *mysql_more_results)(MYSQL *mysql);
int (STDCALL *mysql_next_result)(MYSQL *mysql);
int (STDCALL *mysql_stmt_next_result)(MYSQL_STMT *stmt);
void (STDCALL *mysql_close)(MYSQL *sock);

class Db : private cExternalModule
{
	friend class Stmt;
	class cErr : public std::runtime_error
	{
	private:
		Db* db_;
	public:
		cErr(Db* db, const std::string prefix ="")
			: std::runtime_error(prefix), db_(db)
		{
			assert(mysql_error);
			assert(mysql_errno);
			assert(con_);
			db_->errno_ = mysql_errno(db_->con_);
			db_->msg_ = mysql_error(db_->con_);
			std::string prefix_ = std::runtime_error::what();
			if (!prefix_.empty()) prefix_ += " : ";
			db_->msg_.insert(0, prefix_);
		}
		virtual const char* what() const throw()
		{
			::OutputDebugStringA(db_->msg_.c_str());
			return db_->msg_.c_str();
		}
		virtual ~cErr()
		{}
	};
private:
	unsigned int errno_ ;
	std::string msg_;
	// initializes entry point.
	Db(const std::string& sModuleName, const char *host
		, const char *user, const char *passwd, const char *db, unsigned int port)
		: cExternalModule(sModuleName)
		, errno_(0)
	{
		vGetProcAddr("mysql_character_set_name", mysql_character_set_name);
		vGetProcAddr("mysql_set_character_set", mysql_set_character_set);
		vGetProcAddr("mysql_init", mysql_init);
		vGetProcAddr("mysql_ssl_set", mysql_ssl_set);
		vGetProcAddr("mysql_get_ssl_cipher", mysql_get_ssl_cipher);
		vGetProcAddr("mysql_errno", mysql_errno);
		vGetProcAddr("mysql_error", mysql_error);
		vGetProcAddr("mysql_real_connect", mysql_real_connect);
		vGetProcAddr("mysql_query", mysql_query);
		vGetProcAddr("mysql_use_result", mysql_use_result);
		vGetProcAddr("mysql_get_client_version", mysql_get_client_version);
		vGetProcAddr("mysql_get_server_version", mysql_get_server_version);
		vGetProcAddr("mysql_options", mysql_options);
		vGetProcAddr("mysql_free_result", mysql_free_result);
		vGetProcAddr("mysql_fetch_row", mysql_fetch_row);
		vGetProcAddr("mysql_thread_safe", mysql_thread_safe);
		vGetProcAddr("mysql_stmt_init", mysql_stmt_init);
		vGetProcAddr("mysql_stmt_prepare", mysql_stmt_prepare);
		vGetProcAddr("mysql_stmt_execute", mysql_stmt_execute);
		vGetProcAddr("mysql_stmt_fetch", mysql_stmt_fetch);
		vGetProcAddr("mysql_stmt_fetch_column", mysql_stmt_fetch_column);
		vGetProcAddr("mysql_stmt_store_result", mysql_stmt_store_result);
		vGetProcAddr("mysql_stmt_param_count", mysql_stmt_param_count);
		vGetProcAddr("mysql_stmt_attr_set", mysql_stmt_attr_set);
		vGetProcAddr("mysql_stmt_attr_get", mysql_stmt_attr_get);
		vGetProcAddr("mysql_stmt_bind_param", mysql_stmt_bind_param);
		vGetProcAddr("mysql_stmt_bind_result", mysql_stmt_bind_result);
		vGetProcAddr("mysql_stmt_close", mysql_stmt_close);
		vGetProcAddr("mysql_stmt_reset", mysql_stmt_reset);
		vGetProcAddr("mysql_stmt_free_result", mysql_stmt_free_result);
		vGetProcAddr("mysql_stmt_send_long_data", mysql_stmt_send_long_data);
		vGetProcAddr("mysql_stmt_result_metadata", mysql_stmt_result_metadata);
		vGetProcAddr("mysql_stmt_param_metadata", mysql_stmt_param_metadata);
		vGetProcAddr("mysql_stmt_errno", mysql_stmt_errno);
		vGetProcAddr("mysql_stmt_error", mysql_stmt_error);
		vGetProcAddr("mysql_stmt_sqlstate", mysql_stmt_sqlstate);
		vGetProcAddr("mysql_stmt_row_seek", mysql_stmt_row_seek);
		vGetProcAddr("mysql_stmt_row_tell", mysql_stmt_row_tell);
		vGetProcAddr("mysql_stmt_data_seek", mysql_stmt_data_seek);
		vGetProcAddr("mysql_stmt_num_rows", mysql_stmt_num_rows);
		vGetProcAddr("mysql_stmt_affected_rows", mysql_stmt_affected_rows);
		vGetProcAddr("mysql_stmt_insert_id", mysql_stmt_insert_id);
		vGetProcAddr("mysql_stmt_field_count", mysql_stmt_field_count);
		vGetProcAddr("mysql_commit", mysql_commit);
		vGetProcAddr("mysql_rollback", mysql_rollback);
		vGetProcAddr("mysql_autocommit", mysql_autocommit);
		vGetProcAddr("mysql_more_results", mysql_more_results);
		vGetProcAddr("mysql_next_result", mysql_next_result);
		vGetProcAddr("mysql_stmt_next_result", mysql_stmt_next_result);
		vGetProcAddr("mysql_close", mysql_close);
		// vGetProcAddr("", );
		con_ = mysql_init(NULL);
		std::cout << "Client version " 
			<< GetVerStr(mysql_get_client_version()) << std::endl;
		int int_rc = mysql_options(con_, MYSQL_OPT_COMPRESS, NULL);
		if (int_rc != 0) throw cErr(this, __FUNCTION__);
		std::cout << "Attempting to connect to " << user << "@" 
			<<  host << ":" << port << std::endl;
		MYSQL* rc = mysql_real_connect(con_, host, user, passwd
				, db, port, NULL, 0);
		if (rc == NULL) throw cErr(this, __FUNCTION__);
		std::cout << "Server version " 
			<< GetVerStr(mysql_get_server_version(con_)) << std::endl;
		my_bool bool_val = mysql_autocommit(con_, 0); // makes autocomit mode turning off.
		if (bool_val != 0) throw cErr(this, __FUNCTION__);
		std::cout << "Thread safety is "
			<< (mysql_thread_safe() ? "true" : "false") << "." << std::endl;
		std::string::const_pointer ptr = mysql_character_set_name(con_);
		std::string::size_type len = ::strlen(ptr);
		std::string charset (&ptr[0], &ptr[len]);
		std::cout << "Current charset is " << charset;
		if (charset == "latin1")
		{
			if (mysql_set_character_set(con_, "cp932") != 0)
				throw cErr(this, __FUNCTION__);
			std::cout << ", but changed to charset " << "cp932";
		}
		std::cout << "." << std::endl;
	}
	static std::string GetVerStr(unsigned long ver)
	{
		unsigned long c1,c2,c3;
		c1 = ver % 100;
		ver /= 100;
		c2 = ver % 100;
		ver /= 100;
		c3 = ver % 100;
		ver /= 100;
		std::ostringstream oss;
		oss << c3 << "." << c2 << "." << c1;
		return oss.str();
	}
public:
	static MYSQL* con_ ;
	static Db* StartSession(const char* libpath, const char *host
		, const char *user, const char *passwd, const char *db, unsigned int port)
	{
		static Db inst(libpath, host, user, passwd, db, port);
		return &inst;
	}
	~Db()
	{
		if (con_)
		{
			if (errno_) { mysql_rollback(con_); }
			else        { mysql_commit(con_); }
			mysql_close(con_);
		}
	}
	void Commit()
	{
		mysql_commit(con_);
	}
	void Rollback()
	{
		mysql_rollback(con_);
	}
};

MYSQL* Db::con_ =0;

class Stmt
{
private:
	Db* db_;
	MYSQL_STMT* stmt_;
	std::string sql_;
	unsigned long num_params_;
	std::unique_ptr<MYSQL_BIND []> params_;
	my_ulonglong rows_;    // indicates number of affected rows.
	Stmt(const Stmt& rhs);
	Stmt& operator=(const Stmt& rhs);
	void ExecuteImmediate(const std::string& sql)
	{
		assert(db_->con_);
		assert(!sql.empty());
		int rc = mysql_query(db_->con_, sql.c_str());
		if (rc != 0) throw Db::cErr(db_, __FUNCTION__);
	}
	struct Enque
	{
		Stmt* stmt_;
		Enque(Stmt *stmt, const std::string& table_name)
			: stmt_(stmt)
		{
			std::ostringstream oss;
			oss << "LOCK TABLES " << table_name  << " WRITE";
			stmt_->ExecuteImmediate(oss.str());
		}
		~Enque()
		{
			std::ostringstream oss;
			oss << "UNLOCK TABLES";
			stmt_->ExecuteImmediate(oss.str());
		}
	};
	std::unique_ptr<Enque> lock_table;
public:
	Stmt(Db* db)
		: db_(db), stmt_(0), num_params_(0), rows_(0)
	{
		assert(db_->con_);
		assert(mysql_stmt_init);
		stmt_ = mysql_stmt_init(db_->con_);
		if (stmt_ == NULL) throw Db::cErr(db_, __FUNCTION__);
	}
	~Stmt()
	{
		if (stmt_) mysql_stmt_close(stmt_);
	}
	std::string GenerateInsStmt(
		const std::string& t_table_name
		, const strlist& fldarr
		, const int& bulk_size
	){
		assert(!t_table_name.empty());
		assert(!fldarr.empty());
		// organizes a INSERT statement.
		std::ostringstream oss;
		int i=0;
		oss << "INSERT INTO " << t_table_name;
		for (auto item : fldarr)
		{
			oss << (i ? ',' : '(') << item; ++i;
		}
		int num_fields = i;
		for (int n=0; n < bulk_size; ++n)
		{
			oss << (n ? ", " : ") VALUES ");
			for (i = 0; i < num_fields; ++i)
			{
				oss << (i ? ',' : '(') << '?'; 
			}
			oss << ")";
		}
		lock_table.reset(new Enque(this, t_table_name));
		return oss.str();
	}
	void Prepare(const std::string& sql)
	{
		assert(!sql.empty());
		assert(stmt_);
		sql_ = sql;
		int rc = mysql_stmt_prepare(stmt_, sql_.c_str(), sql_.size());
		if (rc != 0) throw Db::cErr(db_, __FUNCTION__);
		num_params_ = mysql_stmt_param_count(stmt_);
		params_.reset(new MYSQL_BIND[num_params_]);
		for (unsigned long i=0; i < num_params_; ++i)
			memset(&params_[i], 0, sizeof(MYSQL_BIND));
	}
	void MapParam(
		const unsigned long& idx
		, unsigned long* length
		, my_bool* is_null
		, const char* buffer
		, enum enum_field_types buffer_type
	){
		assert(idx < num_params_);
		params_[idx].length = length;
		params_[idx].is_null = is_null;
		params_[idx].buffer = (void*) buffer;
		params_[idx].buffer_type = buffer_type;
	}
	void Execute()
	{
		my_bool bool_val = mysql_stmt_bind_param(stmt_, params_.get());
		if (bool_val != 0) throw Db::cErr(db_, __FUNCTION__);
		int rc = mysql_stmt_execute(stmt_);
		if (rc != 0) throw Db::cErr(db_, __FUNCTION__);
		rows_ += mysql_stmt_affected_rows(stmt_);
	}
	int GetNumFields() const
	{
		return static_cast<int>(num_params_);
	}
};

} // nsMysql

extern nsMysql::Db* mysql;
nsMysql::Db* mysql =0;

class Chrono
{
private:
	std::chrono::system_clock::time_point start;
public:
	Chrono()
		: start(std::chrono::system_clock::now())
	{}
	long long get_elapsed()
	{
		auto end = std::chrono::system_clock::now();
		return std::chrono::duration_cast<std::chrono::milliseconds>
			(end - start).count();
	}
};

struct Console : private std::mutex
{
	void printStdout(const std::string& msg)
	{
		std::unique_lock<std::mutex> lock(*this);
		std::cout << msg << std::endl;
	}
	void printStderr(const std::string& msg)
	{
		std::unique_lock<std::mutex> lock(*this);
		std::cerr << msg << std::endl;
	}
};

// XbhEZ[tۏ؂ꂽR\[
static Console con;

class cInStream
{
private:
	std::string fn_;
	std::ios_base::openmode mode_;
	std::ifstream ifs;
	const int buf_size_;
	std::unique_ptr<char[]> mem_;
	void init()
	{
		long iMSecs = 2;
		con.printStderr("Waiting for " + fn_  + "...");
		for (;;)
		{
			ifs.open(fn_, mode_);
			if (ifs) break;
			if (iMSecs < 100) iMSecs += 2;
			std::chrono::milliseconds dura( iMSecs );
			std::this_thread::sleep_for( dura );
		}
		if (ifs.fail())
		{
			con.printStderr("*** Failed to open: " + fn_ + " ***" );
		}
	}
protected:
	cInStream(const int buf_size = 1<<10)
		: buf_size_(buf_size)
		, mem_(new char[buf_size_])
	{}
	cInStream(const std::string& fn, const std::ios_base::openmode& mode
		, const int buf_size = 1<<10)
		: fn_(std::string(src_header) + fn) 
		, mode_(mode)
		, buf_size_(buf_size)
		, mem_(new char[buf_size_])
	{
		init();
	}
	virtual ~cInStream()
	{}
	bool GetStatus() const
	{
		return ifs.operator!();
	}
	std::ifstream& ReadInSize(std::string& buf, const std::streamsize& count)
	{
		if (ifs.read(mem_.get(), count))
		{
			buf.assign(mem_.get(), mem_.get() + ifs.gcount());
		}
		return ifs;
	}
	std::ifstream& ReadLine(std::string& buf)
	{
		if (ifs.getline(mem_.get(), buf_size_))
		{
			buf.assign(mem_.get(), mem_.get() + ifs.gcount() - 1);
		}
		return ifs;
	}
};

struct Param
{
	std::string data_;
	unsigned long length_;
	char is_null_; // 0: is not null, 1: is null.
	enum enum_field_types buffer_type_;
	Param()
		: data_(""), length_(0), is_null_(0), buffer_type_(MYSQL_TYPE_NULL)
	{}
};

typedef std::vector<Param> paramvector;

std::string ScanValue(
	const char* regular
	, std::string subject
	, const int& matche_pos
){
	cmatch result;
	if (std::regex_search(subject, result, regex(regular)))
	{
		return result.str(matche_pos);
	}
	return "";
}

class cErrNotDefined : public std::runtime_error
{
private:
	std::string msg;
public:
	cErrNotDefined(const std::string& prefix, const std::string& name)
		: std::runtime_error(prefix)
		, msg(std::string("field type: ") + name + " is not defined.")
	{
		std::string prefix_ = std::runtime_error::what();
		if (!prefix_.empty()) prefix_ += " : ";
		msg.insert(0, prefix_);
	}
	virtual const char* what() const throw()
	{
		::OutputDebugStringA(msg.c_str());
		return msg.c_str();
	}
};

class cFaildToSearch : public std::runtime_error
{
private:
	std::string msg;
public:
	cFaildToSearch(const std::string& prefix, const std::string& name)
		: std::runtime_error(prefix)
		, msg(std::string("Failed during search for ") + name + ".")
	{
		std::string prefix_ = std::runtime_error::what();
		if (!prefix_.empty()) prefix_ += " : ";
		msg.insert(0, prefix_);
	}
	virtual const char* what() const throw()
	{
		::OutputDebugStringA(msg.c_str());
		return msg.c_str();
	}
};

// ef[^^ɂĂϊ̒
struct tFormatConverter
{
	static tFormatConverter * makeInstance(const std::string&, const std::string& ="");
	virtual std::string::size_type operator()(
		paramvector::reference, const std::string&, std::string::size_type
	) =0;
	virtual ~tFormatConverter()
	{}
};

typedef std::vector<std::shared_ptr<tFormatConverter> > cnvvector;

class fDecimal : public tFormatConverter
{
public:
	fDecimal() {}
	std::string::size_type operator()(
		paramvector::reference param, const std::string& buf, std::string::size_type pos
	){
		std::string::size_type next = buf.find_first_not_of("0123456789e.-+", pos);
		param.data_.assign(&buf[pos], &buf[next]);
		param.length_ = next - pos;
		param.is_null_ = next > pos ? 0 : 1;
		param.buffer_type_ = param.is_null_ ? MYSQL_TYPE_NULL : MYSQL_TYPE_STRING;
		return next;
	}
};

class fChar : public tFormatConverter
{
private:
	const std::string& enclosure_, enclosure2_;
public:
	fChar(const std::string& enclosure, const std::string& enclosure2)
		: enclosure_(enclosure), enclosure2_(enclosure2)
	{}
	std::string::size_type operator()(
		paramvector::reference param, const std::string& buf , std::string::size_type pos
	){
		pos += enclosure_.size();
		std::string::size_type next = buf.find(enclosure2_, pos);
		if (std::string::npos == next) throw cFaildToSearch(__FUNCTION__, enclosure2_);
		param.data_.assign(&buf[pos], &buf[next]);
		param.length_ = next - pos;
		param.is_null_ = next > pos ? 0 : 1;
		param.buffer_type_ = param.is_null_ ? MYSQL_TYPE_NULL : MYSQL_TYPE_STRING;
		next += enclosure2_.size();
		return next;
	}
};

template<typename T>
class cLobImpl
{
private:
	std::string fn_;
	std::ios_base::openmode mode_;
	std::unique_ptr<T[]> str_;
	unsigned int max_length_;
	const std::string& enclosure_, enclosure2_;
protected:
	std::mutex mtx_;
	std::basic_ifstream<T> ifs;
	cLobImpl(
		const std::string& fn, const std::ios_base::openmode& mode
		, const std::string& enclosure, const std::string& enclosure2
	)
		: fn_(std::string(src_header) + fn), mode_(mode), max_length_(0)
		, enclosure_(enclosure), enclosure2_(enclosure2)
	{
		long iMSecs = 2;
		for (;;)
		{
			ifs.open(fn_, mode_);
			if (ifs) break;
			if (iMSecs < 100) iMSecs += 2;
			std::chrono::milliseconds dura( iMSecs );
			std::this_thread::sleep_for( dura );
		}
		if (ifs.fail())
		{
			con.printStderr("*** Failed to open: " + fn_ + " ***" );
		}
	}
	std::basic_ifstream<T>& ReadInSize(T*& ptr, const unsigned int& count)
	{
		if (count > max_length_)
		{
			max_length_ = count;
			str_.reset(new T[max_length_ + 1]);
		}
		if (ifs.read(str_.get(), count))
		{
			ptr = str_.get();
			ptr[ifs.gcount()] = T(0);
		}
		return ifs;
	}
	template<class Pred>
	size_t iBindToLob(paramvector::reference param
		, const std::string& buf, std::string::size_type pos
		, Pred pred, enum enum_field_types buffer_type)
	{
		pos += enclosure_.size();
		std::string::size_type next = buf.find(enclosure2_, pos);
		if (std::string::npos == next) throw cFaildToSearch(__FUNCTION__, enclosure2_);
		if (std::string(&buf[pos], &buf[next]) != "NONE")
		{
			pred(param);
		}
		else
		{
			param.data_= "";
			param.length_ = 0;
			param.is_null_ = 1;
		}
		param.buffer_type_ = param.is_null_ ? MYSQL_TYPE_NULL : buffer_type;
		next += enclosure2_.size();
		return next;
	}
};

class fCLob
	: public tFormatConverter
	, private cLobImpl<wchar_t>
{
public:
	std::unique_ptr<char[]> mbs_;
	unsigned int max_length_;
	fCLob(const std::string& fn, const std::string& enclosure, const std::string& enclosure2)
		: cLobImpl(fn, std::ifstream::in | std::ifstream::binary, enclosure, enclosure2)
		  , max_length_(0)
	{
		std::locale loc (std::locale(), new std::codecvt_utf16<wchar_t>);
		ifs.imbue(loc);
		wchar_t *bom;
		ReadInSize(bom, 1); // UTF-16BE  BOM QoCg
	}
	std::wstring::size_type operator()(
		paramvector::reference param, const std::string& buf , std::string::size_type pos
	){
		std::unique_lock<std::mutex> lock(mtx_);
		return iBindToLob(param, buf, pos, [&](paramvector::reference param)
			{
				wchar_t *ptr;
				ReadInSize(ptr, VAR_FIELD_LENGTH);
				int count = 0;
				std::wistringstream(std::wstring(ptr, VAR_FIELD_LENGTH)) >> count;
				assert(count >= 0 && count < MAX_VALUE_LENGTH);
				ReadInSize(ptr, count);
				if (count * sizeof(wchar_t) > max_length_)
				{
					max_length_ = count * sizeof(wchar_t);
					mbs_.reset(new char[max_length_ + 1]);
				}
				param.length_ = std::wcstombs(mbs_.get(), ptr, max_length_);
				param.data_.assign(mbs_.get(), param.length_);
				param.is_null_ = 0;
			}, MYSQL_TYPE_STRING
		);
	}
};

class fBLob
	: public tFormatConverter
	, private cLobImpl<char>
{
public:
	fBLob(const std::string& fn, const std::string& enclosure, const std::string& enclosure2)
		: cLobImpl(fn, std::ifstream::in | std::ifstream::binary, enclosure, enclosure2)
	{}
	std::string::size_type operator()(
		paramvector::reference param, const std::string& buf , std::string::size_type pos
	){
		std::unique_lock<std::mutex> lock(mtx_);
		return iBindToLob(param, buf, pos, [&](paramvector::reference param)
			{
				char *ptr;
				ReadInSize(ptr, sizeof(int));
				int count = *((int*) ptr);
				assert(count >= 0 && count < MAX_VALUE_LENGTH);
				ReadInSize(ptr, count);
				param.data_.assign(ptr, count);
				param.length_ = param.data_.size();
				param.is_null_ = 0;
			}, MYSQL_TYPE_BLOB
		);
	}
};

class fLongRaw : public tFormatConverter
{
public:
	fLongRaw() {}
	std::string::size_type operator()(
		paramvector::reference param, const std::string& buf, std::string::size_type pos
	){
		int count = *((int*) &buf[pos]);
		assert(count >= 0 && count < MAX_VALUE_LENGTH);
		pos += sizeof(int);
		std::string::size_type next = pos + count;
		param.data_.assign(&buf[pos], &buf[next]);
		param.length_ = next - pos;
		param.is_null_ = next > pos ? 0 : 1;
		param.buffer_type_ = param.is_null_ ? MYSQL_TYPE_NULL : MYSQL_TYPE_BLOB;
		return next;
	}
};

class fLongStr : public tFormatConverter
{
public:
	fLongStr() {}
	std::string::size_type operator()(
		paramvector::reference param, const std::string& buf, std::string::size_type pos
	){
		int count = 0;
		std::istringstream(std::string(&buf[pos], VAR_FIELD_LENGTH)) >> count;
		assert(count >= 0 && count < MAX_VALUE_LENGTH);
		pos += VAR_FIELD_LENGTH;
		std::string::size_type next = pos + count;
		param.data_.assign(&buf[pos], &buf[next]);
		param.length_ = next - pos;
		param.is_null_ = next > pos ? 0 : 1;
		param.buffer_type_ = param.is_null_ ? MYSQL_TYPE_NULL : MYSQL_TYPE_STRING;
		return next;
	}
};

tFormatConverter * tFormatConverter::makeInstance(
	const std::string& ty, const std::string& opt
){
	const static std::string enclosure_(STR_ENCLOSURE), enclosure2_(STR_ENCLOSURE);
	if (ty.compare(0, 7, "DECIMAL") == 0)
	{
		return new fDecimal;
	}
	else if (
		ty.compare(0, 4, "CHAR") == 0
		|| ty.compare(0, 4, "DATE") == 0
	){
		return new fChar(enclosure_, enclosure2_);
	}
	else if (ty.compare(0, 7, "LOBFILE") == 0)
	{
		// SDF ؂
		const std::string lobf = ScanValue("CONSTANT '([0-9A-Z_]+\\.[bc]lo)'", opt, 1);
		assert(!lobf.empty());
		if (std::string(lobf.end() - 3, lobf.end()) == "clo")
		{
			return new fCLob(lobf, enclosure_, enclosure2_);
		}
		else
		{
			return new fBLob(lobf, enclosure_, enclosure2_);
		}
	}
	else if (ty.compare(0, 11, "LONG VARRAW") == 0)
	{
		return new fLongRaw;
	}
	else if (ty.compare(0, 8, "VARCHARC") == 0)
	{
		return new fLongStr;
	}
	else /* others */
	{
		throw cErrNotDefined(__FUNCTION__, ty);
	}
}

// Control file object
class cCtlFile : private cInStream
{
private:
	std::string ctrl_stmt;
	strvector dtype;
	std::map<int, std::string> subtyp;  // ^ɊւTuiJbR̎j
	template<class Predicate>
	void ScanValAddToArray(
		const char* regular
		, std::string::const_iterator first
		, std::string::const_iterator last
		, const intvector& submatches
		, Predicate pred
	){
		std::regex_token_iterator<std::string::const_iterator> rend;
		regex ex_regular(regular);
		int num_matches = 0;
		// regex_token_iterator()  4 Ԗڂ̈
		// K\ɂv[XtH_̈ʒu: \<submatches> ̈ӖB
		// ȗl 0 ̓p^Ŝ
		std::regex_token_iterator<std::string::const_iterator> it_matched
			= std::regex_token_iterator<std::string::const_iterator>(
				first, last, ex_regular, submatches);
		while (it_matched != rend) 
		{
			pred(it_matched->str(), num_matches % submatches.size());
			it_matched++;
			num_matches++;
		}
	}
public:
	cCtlFile(const std::string& fn)
		: cInStream(fn, std::ifstream::in)
	{}
	bool operator!() const
	{
		return GetStatus();
	}
	void ReadToCache()
	{
		std::string buf;
		while (ReadLine(buf))
		{
			ctrl_stmt += buf;
			ctrl_stmt += '\n';
		}
	}
	~cCtlFile()
	{}
	void Parse(
		std::string& table_name         // shows target table name.
		, std::string& terminator       // is field separator.
		, strvector& dfarr              // contains data file names.
		, intvector& varlenarr          // "VAR n"
		, strlist& fldarr               // contains names of fields.
	){
		table_name = ScanValue("INTO TABLE \"([^\"]*)\"" , ctrl_stmt, 1);
		assert(!table_name.empty());
		terminator = ScanValue("TERMINATED BY '([^']*)'" , ctrl_stmt, 1);
		assert(!terminator.empty());
		// searches datafiles.
		intvector submatches;
		intvector::value_type cur_pos = 0;
		submatches.push_back(1);
		submatches.push_back(2); // Tu}b`ӏ 2 ӏ
		ScanValAddToArray(
			"INFILE \"([^\"]*)\" \"VAR ([1-9][0-9]*)\""
			, ctrl_stmt.begin(), ctrl_stmt.end(), submatches
			, [&] (const std::string& item, const int pos)
			{
				switch (pos)
				{
				case 0:
					dfarr.push_back(item);
					break;
				case 1:
					int varlen;
					std::istringstream(item) >> varlen;
					varlenarr.push_back(varlen);
					break;
				}
			});
		// searches lob field names.
		submatches.push_back(3); // Tu}b`ӏ 3 ӏ
		ScanValAddToArray(
			"[\\(,]\\s+\"([^\"]*)\"\\s+([A-Z]+|DECIMAL EXTERNAL|LOBFILE |LONG VARRAW|VARCHARC)\\(([1-9][,0-9]*|CONSTANT '[0-9A-Z_]+\\.[bc]lo').*\\)"
			, ctrl_stmt.begin(), ctrl_stmt.end(), submatches
			, [&] (const std::string& item, const int pos)
			{
				switch (pos)
				{
				case 0:
					fldarr.push_back(item);
					cur_pos++;
					break;
				case 1:
					dtype.push_back(item);
					break;
				case 2:
					subtyp[cur_pos - 1] = item;
					break;
				}
			});
	}
	void ScanFields(
		cnvvector& cnvarr         // contains type of fieds..
	){
		intvector::value_type cur_pos = 0;
		for (const auto ty : dtype)
		{
			cnvarr.push_back(
				cnvvector::value_type(
					tFormatConverter::makeInstance(ty, subtyp[cur_pos])
				)
			);
			++cur_pos;
		}
	}
};

// Datafile object
class cDatFile : private cInStream
{
private:
	std::string terminator_;
	const int varlen_;
	paramvector param_arr_;
	const strlist& fldarr_;
	nsMysql::Db* mysql_;
	void BindData(
		const cnvvector& cnvarr
		, const strvector& buf_arr
		, const int num_rows
		, const int num_fields
		, nsMysql::Stmt& stmt
	){
		intvector pos(num_rows, 0), next(num_rows, 0);
		for (int i=0; i < num_fields; ++i)
		{
			for (int j=0; j < num_rows; ++j)
			{
				int prm_id = j * num_fields + i;
				paramvector::reference param = param_arr_[prm_id];
				// invokes tFormatConverter::operator()(paramvector::reference, ...)
				next[j] = (*cnvarr[i])(param, buf_arr[j], pos[j]);
				stmt.MapParam(prm_id, &param.length_, &param.is_null_
						, param.data_.c_str(), param.buffer_type_);
				pos[j] = next[j] + terminator_.size();
			};
		}
	}
	void ShowStat(const int& num_rows) const
	{
		std::ostringstream toss;
		toss << num_rows << " rows processed.";
		con.printStdout(toss.str());
		toss.str("");
	}
public:
	cDatFile(
		const std::string& fn
		, const std::string& terminator
		, const int& varlen
		, const strlist& fldarr
		, nsMysql::Db* mysql
	)
		: cInStream(fn, std::ifstream::in | std::ifstream::binary)
		, terminator_(terminator)
		, varlen_(varlen)
		, fldarr_(fldarr)
		, mysql_(mysql)
	{}
	bool operator!() const
	{
		return GetStatus();
	}
	~cDatFile()
	{}
	// f[^t@CsǂݎāAMySQL C API ֓n
	void ReadDfAndOutput(
		const int& bulk_size
		, const std::string& table_name
		, const cnvvector& cnvarr
	){
		nsMysql::Stmt stmt(mysql_);
		// generates "INSERT INTO <table_name>".
		stmt.Prepare(stmt.GenerateInsStmt(table_name, fldarr_, bulk_size));
		int num_fields = stmt.GetNumFields();
		// oNɑɕKvȃp[^𑵂
		param_arr_.assign(bulk_size * cnvarr.size(), paramvector::value_type());
		// CSV JnO varlen_ ̕ɁAɑ CSV ̒
		// oCgPʂŎĂ
		int num_rows = 0, iters;
		strvector buf_arr(bulk_size);
		for (;;)
		{
			iters = num_rows % bulk_size;
			std::string& buf = buf_arr[iters];
			if (!ReadInSize(buf, varlen_)) break;
			int count;
			std::istringstream(buf) >> count;
			assert(count >= 0 && count < MAX_VALUE_LENGTH);
			ReadInSize(buf, count); // 㑱 CSV ǂݎ
			// oN
			if (iters == bulk_size - 1)
			{
				BindData(cnvarr, buf_arr, bulk_size, fldarr_.size(), stmt);
				stmt.Execute();
			}
			if (num_rows % INTERVAL_FOR_EACH_COMMIT == 0)
			{
				mysql_->Commit();
				if (num_rows)
				{
					ShowStat(num_rows);
				}
				else
				{
					std::ostringstream toss;
					toss << "Reading records... ";
					con.printStdout(toss.str());
				}
			}
			num_rows++;
		}
		// oNȂ؂[
		if (iters)
		{
			stmt.Prepare(stmt.GenerateInsStmt(table_name, fldarr_, iters));
			BindData(cnvarr, buf_arr, iters, fldarr_.size(), stmt);
			stmt.Execute();
		}
		ShowStat(num_rows);
	}
};

int main(int argc, char* argv[])
try
{
	std::string caption = 
		"MTU adaptor for MySQL version 1.1, Copyright (c) 2014 Plumsix Co.,Ltd.\n\n"
		"This program is distributed in the hope that it will be useful,\n"
		"but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
		"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
		"GNU General Public License for more details.\n"
		;
	con.printStdout(caption);

	if (argc < 4)
	{
		caption =
			"Usage: AdpMysql <table_name> <bulk_size> "
			"[path_to_mysql_home_dir\\lib\\]libmysql.dll>";
		con.printStderr(caption);
		return 1;
	}

	setlocale(LC_CTYPE,"");         // ̎}`oCgKp

	Chrono stop_watch;

	// Activating MySQL connectivity.
	mysql = nsMysql::Db::StartSession(argv[3], HOST, USER, PASSWD, DB, PORT);

	cCtlFile cf(std::string(argv[1]) + ".ctl");
	if (!cf) return 2; 
	cf.ReadToCache();

	std::string table_name; 
	std::string terminator;         // column values separator
	strvector dfarr;                // array of data file(s)
	intvector varlenarr;            // array of row length value(s)
	strlist fldarr;                 // list of column names
	cnvvector cnvarr;               // ϊp֐IuWFNgz
	cf.Parse(table_name, terminator, dfarr, varlenarr, fldarr);
	
	for (strvector::size_type i = 0; i < dfarr.size(); i++)
	{
		cDatFile df(dfarr[i] + ".dat"
			, terminator, varlenarr[i], fldarr, mysql);
		if (!df) return 3; 
		if (cnvarr.empty()) cf.ScanFields(cnvarr); // SDF  open 
		           // ܂܂̂ŃnOh~ׁ̈AcDatFile::cDatFile() 
				   // łȂ΂ȂȂ
		df.ReadDfAndOutput(atoi(argv[2]), table_name, cnvarr);
	}
	std::ostringstream toss;
    toss << "Elapsed time = " << stop_watch.get_elapsed() / 1000.0
		<< " sec." << std::endl;
	con.printStdout(toss.str() + "Completed successfully.");
	return 0;
}
catch (const std::runtime_error& e)
{
	std::cerr << "Error - " << e.what() << std::endl;
	con.printStdout("Faild with an error.");
	return 5;
}
